function IntegracaoRDStationController(templateManager, ScreenService, restEngine, General, Messages, metaDataFactory,CRM_Utilities){
    var LINK_CRM = 'https://crm.teknisa.com/backend/index.php';
    var LINK_CRM_CLOUD = 'https://crm.teknisa.cloud/backend/index.php';
    
     CRM_Utilities.addController(this, 'IntegracaoRDStationController');
    
    /**
     *      PARAMETRIZACAO
    */
    
    /**
     * Inicia a integração com o RDStation, 
     * chamando a rota de autenticação e salvando
     * o refresh token no templateManager.CRM_PARAMETRIZACAO.
    */
    this.authRDStation = function(widget){
        var self = this;
        if(Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD) && templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD){
            var x = screen.width/2 - 900/2 - 50;
            var y = screen.height/2 - 600/2 - 50;
            var redirect_url = (window.location.href.indexOf('cloud') !== -1) ? LINK_CRM_CLOUD : LINK_CRM;
            redirect_url += '/IntegracaoRDStation/auth';
            var popupSendContact = window.open('https://api.rd.services/auth/dialog?client_id=2de5e1c4-b917-4d0b-9356-7a67c6a89362&redirect_url='+redirect_url, 'popup','height=600,width=900,top='+y+',left='+x);
            
            if(popupSendContact !== null){
                ScreenService.changeLoadingMessage('Aguardando autorização...');
                ScreenService.showLoader();
                
                function removeListener(event) {
                    window.removeEventListener("message", removeListener);
                    if(event.data.success === false && !window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('Não foi possível conectar com o RD Station, tente novamente! <br> Se o erro persistir contate um administrador.');    
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }else if(event.data.closedByUser === true && !window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('Não foi possível conectar com o RD Station, a janela de autorização foi fechada.');    
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                    }else if(!window.authRDFinished){
                        window.authRDFinished = true;
                        ScreenService.showMessage('RD Station conectado!');  
                        ScreenService.hideLoader();
                        ScreenService.restoreDefaultLoadingMessage();
                        templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD = event.data.refreshToken;
                        self.showCustomFieldAction();
                    }
                }
                var timer = setInterval(function() { 
                    if(popupSendContact.closed) {
                        clearInterval(timer);
                        removeListener({data:{closedByUser:true}});
                        window.authRDFinished = false;
                    }
                }, 1000);
                
                window.addEventListener("message", removeListener);
            }else{
                ScreenService.showMessage("Popup do navegador bloqueado!<br/>Libere o popup para realizar a sincronização com o RD Station.");
            }
        }
    };
    
    /**
     * Abre o swipe com os passos para configurar a integração
     * no RD Station.
    */
    this.helpRD = function(widget){
        var widHelp = templateManager.container.getWidget('MODAL_HELP');
        var url = (window.location.href.indexOf('cloud') !== -1) ? LINK_CRM_CLOUD : LINK_CRM;
        url += '/IntegracaoRDStation/importLead?organization='+templateManager.LOGGEDOPERATOR.NRORG;
        widHelp.currentRow.URL = url;
        ScreenService.openSwipe(widHelp);
    };
    
    /**
     *      CAMPOS PERSONALIZADOS
    */
    
    /**
     * Copia a url de integração do field para a área de transferência.
    */
    this.copyURLRDStation = function(widget){
        if(!widget.urlCopied){
            var url = widget.currentRow.URL;
            $('body').append('<input id="temp" value='+url+'></input>');
            $('body > #temp').select();
            document.execCommand('copy');
            $('body > #temp').remove();
            ScreenService.successNotification('Url copiada para a área de transferência', 1000);
            //Evita vários clicks no botão;
            widget.urlCopied = true;
            setTimeout(function(){
                widget.urlCopied = false;
            },1200);
        }
    };
    
    /**
     * Abre o popup de campos personalizados.
    */
    this.openModalCustomField = function(widget){
        var widCustomField = templateManager.container.getWidget('MODAL_CUSTOM_FIELD');
        ScreenService.openPopup(widCustomField);
        widCustomField.reload();
    };
    
    /**
     * New row na widget de campos personalizados.
    */
    this.addField = function(widget){
        widget.template = 'widget/form.html';
        widget.edit();
        widget.currentRow = {};
        ScreenService.openPopup(widget);
    };
    
    /**
     * Cancel na widget de campos personalizados
    */
    this.cancelNewField = function(widget){
        widget.template = 'widget/grid.html';
        widget.list();
    };
    
    /**
     * Save e Edit na widget de campos personalizados.
    */
    this.saveCustomField = function(widget){
        if(widget.isValid()){
            var paramsRestEngine = {
                "requestType": "Row",
                "row": widget.currentRow
            };
            restEngine.post('/IntegracaoRDStation/saveCustomField', paramsRestEngine).then(function(response){
                if(response && response.dataset){
                    if(Util.isEmptyOrBlank(widget.currentRow.IDUUID)){
                        ScreenService.showMessage('Campo personalizado criado! \n Você pode usá-lo dentro do RDStation.');
                        widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
                		widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
                		widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
                		widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
                		widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
                        widget.currentRow.__columns_to_return = widget.paramsNewCode.__columns_to_return;
                        widget.currentRow.__is_new = true;
                        widget.currentRow.IDUUID = response.dataset.CUSTOM_FIELD['uuid'];
                    }
                    widget.currentRow.DSOPCOESCAMPOSELECT = (widget.currentRow.DSOPCOESCAMPOSELECT) ? widget.currentRow.DSOPCOESCAMPOSELECT.join(',') : '';
                    widget.currentRow.NMCAMPORELACIONADO  = (Array.isArray(widget.currentRow.NMCAMPORELACIONADO))  ? widget.currentRow.NMCAMPORELACIONADO.join(',')  :  widget.currentRow.NMCAMPORELACIONADO || '';
                    widget.currentRow.NMTABELARELACIONADA = (Array.isArray(widget.currentRow.NMTABELARELACIONADA)) ? widget.currentRow.NMTABELARELACIONADA.join(',') :  widget.currentRow.NMTABELARELACIONADA || '';
                    widget.saveRow().then(function (){
                        widget.reload().then(function(){
                            this.cancelNewField(widget);
                        }.bind(this));
                    }.bind(this));
                }    
            }.bind(this)).catch(function(error){
                if(error.data.errorCode === 2)
                    ScreenService.showMessage(error.data.error);
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
                
            });
        }
    };
    
    /**
     * Delete na widget de campos personalizados.
    */
    this.deleteFields = function(widget){
        var paramsRestEngine = {
            "requestType": "DataSet",
            "dataset": widget.dataSource.getCheckedRows()
        };
        restEngine.post('/IntegracaoRDStation/deleteCustomFields', paramsRestEngine).then(function(response){
            if(response && response.dataset){
                widget.removeCheckedRows().then(function () {
                    widget.reload();
                });
            }
        }.bind(this)).catch(function(error){
            if(error.data.errorCode === 2)
                ScreenService.showMessage(error.data.error);
            else
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            
        });
    };
    
    /**
     * Controla a visibilidade da action de campos
     * personalizados baseado no templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD
     * e no operador logado.
    */
    this.showCustomFieldAction = function(){
        var widRD = templateManager.container.getWidget('WDGT_PARAM_INTEGRATION_RDSTATION');
        var customFieldAction = widRD.getAction('CREATE_CUSTOM_FIELD');
        if(templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD){
            if(Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSREFRESHTOKENRD)){
                customFieldAction.isVisible = false;
            }else{
                customFieldAction.isVisible = true;
            }
        }else{
            customFieldAction.isVisible = false;
        }
        widRD.activate();
    };
    
    /**
     * Controla a visibilidade e obrigatoriedade do campo
     * de opções baseado no tipo de campo personalizado.
    */
    this.showOptions = function(widget){
        var tipo = widget.currentRow.IDTIPOCAMPORDSTATION;
        if(!Util.isEmptyOrBlank(tipo) && (tipo === 'CHECK_BOX' || tipo === 'MULTIPLE_CHOICE' || tipo === 'COMBO_BOX' || tipo === 'RADIO_BUTTON')){
            widget.getField('DSOPCOESCAMPOSELECT').isVisible = true;
            widget.getField('DSOPCOESCAMPOSELECT').validations = {required:true};
        }else{
            widget.getField('DSOPCOESCAMPOSELECT').isVisible = false;
            widget.getField('DSOPCOESCAMPOSELECT').validations = {};
        }
    };
    
    /**
     * Muda a widget de campos personalizdos para o modo de edit
    */
    this.changeWidgetToEditMode = function(args){
        args.e.preventDefault();
        args.owner.currentRow = args.row;
        args.owner.template = 'widget/form.html';
        args.owner.edit();
    };
    
    /*  FIM CAMPOS PERSONALIZADOS  */
    
    /*  FIM PARAMETRIZACAO  */
    
    /**
     * GERAL
    */
    
    /**
     * Cria a action de enviar para o RD baseado no operador logado
     * e na parametrização DSREFRESHTOKENRD
    */
    this.insertSendActionRD = function(widget, funnel){
        funnel = CRM_Utilities.capitalizeFirstLetter(funnel);
        funnel = (funnel === 'Cliente') ? 'Client' : (funnel === 'Prospect') ? 'Qualified Lead' : 'Lead';
        var hasSendAction = false;
        widget.actions.forEach(function(action){
            if(action.name === 'SEND_RD'){
                hasSendAction = true;
            }
        });
        var needAction = Boolean(!Util.isEmptyOrBlank(templateManager.CRM_PARAMETRIZACAO.DSTOKENPUBLICORD) && templateManager.LOGGEDOPERATOR.CDOPERADOR === templateManager.CRM_PARAMETRIZACAO.CDOPERRESPONSAVELRD);
        if(needAction && !hasSendAction){
            var sendAction = {
                "id":"172231975831131665551239",
                "name": "SEND_RD",
                "label": "Enviar para o RD Station",
                "isVisible": true,
                "preventHide":true,
                "showAsAction": "never_view",
                "events": [
                    {
                        "name": "ActionEvent",
                        "code": "IntegracaoRDStationController.openPopupSendContactToRD(args.owner.widget);"
                    }
                ]
            };
            metaDataFactory.actionFactory(sendAction, widget, true);
            widget.FUNNEL = funnel;
        }else if(needAction && hasSendAction){
            widget.getAction('SEND_RD').isVisible = true;
            widget.FUNNEL = funnel;
        }else if(!needAction && hasSendAction){
            widget.getAction('SEND_RD').isVisible = false;
        }
        widget.activate();
    };
	
	
	this.openPopupSendContactToRD = function(widget){
	    var popupSendContact = {
            "name": "SEND_RD_POPUP",
            "label": "Enviar para o RD Station",
            "isVisible": false,
            "showAsTab": false,
            "template": "widget/form.html",
            "parent":widget,
            "container":widget.container,
            "events": [],
            "actions": [
                {
                    "id": "6182828515686520676545",
                    "name": "enviar",
                    "isVisible": true,
                    "label": "Enviar",
                    "showAsAction": "never",
                    "events": [
                        {
                            "id": "6182828514145614549655",
                            "name": "ActionEvent",
                            "code": "IntegracaoRDStationController.sendContactToRD(args.owner.widget, args.owner.widget.parent.parent)"
                        }
                    ]
                },
                {
                    "id": "6182828511372890396656",
                    "name": "cancel",
                    "label": "Voltar",
                    "showAsAction": "back",
                    "events": [
                        {
                            "id": "6182828512205401251657",
                            "name": "ActionEvent",
                            "code": "ScreenService.closePopup(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "61828285113728903966578",
                    "name": "CONVERSION_EVENT",
                    "label": "Evento de Conversão",
                    "template": "field/text-edit.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "defaultValue":"CRM",
                    "minValue": 0,
                    "validations": {
                        "required":true
                    },
                    "events": []
                },
                {
                    "id": "61828285113728903966577",
                    "name": "NAME",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": false,
                    "class": "12",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "validations": {
                        "required":true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                   
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+widget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "EMAILINTERLOC": "EMAIL",
                        "NRTELEFONE1": "PHONE",
                        "NRTELEFONE2": "PHONE_2",
                        "NMINTERLOCUTOR": "NAME",
                        "NMCARGOINTERLOC":"JOB"
                    },
                    "fields": [
                        {
                            
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "155128146334412170291613258",
                    "name": "TAGS",
                    "label": "Tags",
                    "template": "field-tag#field/tag.html",
                    "class": "12",
                    "help":"Separe os tags utilizando ' , ', ' tab ' ou ' enter '.",
                    "isVisible": true,
                    "dataSource":{
                        "data":[]
                    },
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false
                }
            ]
        };  
        
        if(templateManager.container.getWidget('SEND_RD_POPUP') === undefined){
            popupSendContact = metaDataFactory.widgetFactory(popupSendContact);
            widget.widgets.push(popupSendContact);
        }else{
            popupSendContact = templateManager.container.getWidget('SEND_RD_POPUP');
        }
        ScreenService.openPopup(metaDataFactory.widgetFactory(popupSendContact));
	};
	
	/**
	 * Manda o contato para o RD Station,
	 * leads vão como Leads, prospects como Leads Qualificados
	 * e Clientes como Clientes
	*/
	this.sendContactToRD = function(popup, parcWidget){
	    popup.currentRow.FUNNEL = parcWidget.FUNNEL;
	    popup.currentRow.COMPANY = parcWidget.currentRow.NMCANDIDATO || parcWidget.currentRow.NMRAZSOCPROS || parcWidget.currentRow.NOME;
	    popup.currentRow.NR_EMP = parcWidget.currentRow.NRFUNCCAN || parcWidget.currentRow.NRFUNCPROS || '';
	    popup.currentRow.COMPANY_ADDRESS = (parcWidget.currentRow.NMESTADO || '') + ' ' + (parcWidget.currentRow.NMMUNICIPIO || '') + ' ' + (parcWidget.currentRow.NMBAIRROCAN || parcWidget.currentRow.NMBAIRRO || '');
	    popup.currentRow.TAGS = Array.isArray(popup.currentRow.TAGS) ? popup.currentRow.TAGS.join(',') : ''; 
	    popup.currentRow.NRPARCNEGOCIO = parcWidget.currentRow.NRPARCNEGOCIO; 
	    
	    var paramsRestEngine = {
            "requestType": "Row",
            "row": popup.currentRow
        };
        restEngine.post('/IntegracaoRDStation/sendContactToRD', paramsRestEngine).then(function(response){
            if(response && response.dataset){
                ScreenService.showMessage('Parceiro enviado! <br> Você pode manipulá-lo no RD Station');
                ScreenService.closePopup();
            }
        }.bind(this)).catch(function(error){
            if(error.data.errorCode === 2)
                ScreenService.showMessage(error.data.error);
            else
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error.data.error));
            
        });
	};
	
	this.downloadDoc = function(){
        var filename = 'Documentacao_Integracao_RD_CRM.pdf';
        window.open("files/" + filename, "_blank");
	};
}
Configuration(function(ContextRegister){
    ContextRegister.register('IntegracaoRDStationController', IntegracaoRDStationController);
});